# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xmysqldatabase`](#dsc_xmysqldatabase): The DSC xMySqlDatabase resource type. Automatically generated from version 2.0.0.0
* [`dsc_xmysqlgrant`](#dsc_xmysqlgrant): The DSC xMySqlGrant resource type. Automatically generated from version 2.0.0.0
* [`dsc_xmysqlprovision`](#dsc_xmysqlprovision): The DSC  resource type. Automatically generated from version 2.0.0.0
* [`dsc_xmysqlserver`](#dsc_xmysqlserver): The DSC xMySqlServer resource type. Automatically generated from version 2.0.0.0
* [`dsc_xmysqluser`](#dsc_xmysqluser): The DSC xMySqlUser resource type. Automatically generated from version 2.0.0.0

## Resource types

### `dsc_xmysqldatabase`

The DSC xMySqlDatabase resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xmysqldatabase` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should the database be present or absent.

##### `dsc_mysqlversion`

Data type: `String`

MYSql Version Number

#### Parameters

The following parameters are available in the `dsc_xmysqldatabase` type.

##### `dsc_databasename`

namevar

Data type: `String`

Name of the database.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_rootcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The root credential that is used to install MySql server.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xmysqlgrant`

The DSC xMySqlGrant resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xmysqlgrant` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure given grant to mySql database present or absent.

##### `dsc_mysqlversion`

Data type: `String`

MYSql Version Number

#### Parameters

The following parameters are available in the `dsc_xmysqlgrant` type.

##### `dsc_databasename`

namevar

Data type: `String`

MySql database name to grant permissions.

##### `dsc_permissiontype`

namevar

Data type: `Enum['ALL PRIVILEGES', 'CREATE', 'DROP', 'DELETE', 'INSERT', 'SELECT', 'UPDATE', 'EXECUTE']`

MySql user permission type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_rootcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

MySql connection credential used for the root.

##### `dsc_username`

namevar

Data type: `String`

Name of MySQL user.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xmysqlprovision`

The DSC  resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xmysqlprovision` type.

##### `dsc_port`

Data type: `Optional[String]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

#### Parameters

The following parameters are available in the `dsc_xmysqlprovision` type.

##### `dsc_databasename`

namevar

Data type: `String`

 

##### `dsc_downloaduri`

namevar

Data type: `String`

 

##### `dsc_mysqlversion`

namevar

Data type: `String`

 

##### `dsc_permissiontype`

namevar

Data type: `Array[String]`

 

##### `dsc_rootcredential`

namevar

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_usercredential`

namevar

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_username`

namevar

Data type: `String`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xmysqlserver`

The DSC xMySqlServer resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xmysqlserver` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure server is present or absent

##### `dsc_port`

Data type: `Optional[String]`

The port number for the service

#### Parameters

The following parameters are available in the `dsc_xmysqlserver` type.

##### `dsc_mysqlversion`

namevar

Data type: `String`

mySql Version Number

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_rootpassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The root credential that is used to install mySql server.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xmysqluser`

The DSC xMySqlUser resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xmysqluser` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure MySQL user is present or absent.

##### `dsc_mysqlversion`

Data type: `String`

MySQL Version Number

#### Parameters

The following parameters are available in the `dsc_xmysqluser` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_rootcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

MySQL root credential used to create a user.

##### `dsc_usercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential for MySQL user.

##### `dsc_username`

namevar

Data type: `String`

Name of MySQL user to create or remove.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

